;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Diagonal Wipe
;
; PRINT USR DIAG;[Speed],[CODE "X"]
;
;================================

@DFile=400C
@Fill=403C			;Buff1:Fill store, (IY+60)
@Speed=403D			;Buff2:Speed store, (IY+61)

@Class6=0D92			;Expression evaluator
@StackBC=0BF5			;Move results to BC

@Wipe
	RST 20			;Get next character
	LD A,75
	INC A
	CP (HL)
	LD B,00			;Default Fill
	LD A,01			;Default Speed
	JR Z NoPars		;Jump if no value specified
	CALL Class6		;Evaluate [Lines] expression
	RST 20 			;Get next character
	CALL Class6		;Evaluate [CODE "Chr X"] expression
	CALL StackBC		;Move results to BC, B=Chr, A=C=Speed
@NoPars
	LD (IY+60),B		;Store fill
	LD (Speed),A		;Store speed
@Start
	LD HL,(DFile)		;Get DFile
	INC HL 
	LD DE,0001 		;Initialize counter
	LD B,18
@OuterA				;Part 1, Left section
	PUSH DE			;PUSH counter
	PUSH HL		 	;PUSH DFile
	PUSH DE			;PUSH counter
@InnerA
	LD A,(Fill)		;Get Fill chr
	LD (HL),A		;Print it
	LD A,(Speed)		;Get Speed
	DEC A			;Decrease counter
	JR NZ -3 		;Loop until A=0
	LD DE,FFE0		;-32
	ADD HL,DE 		;HL=HL-32
	POP DE 			;POP counter
	DEC E 
	PUSH DE			;PUSH Counter 
	JR NZ InnerA		;Loop until E=0
	POP DE 			;POP counter
	POP HL 			;POP DFile
	LD E,21 		;Start of next row
	ADD HL,DE 
	POP DE 			;POP counter
	INC E
	DJNZ OuterA		;Start next diagonal
;Part 2, Middle section
	LD HL,(DFile)
	INC HL 
	LD DE,02F8 		;DFile offset
	ADD HL,DE 
	LD B,08			;Counter
@OuterB
	PUSH HL 
	LD C,B			;Save B
	LD DE,FFE0 		;-32
	LD B,18
@InnerB
	LD A,(Fill)		;Get fill
	LD (HL),A 		;Print it
	LD A,(Speed)		;Get Speed
	DEC A			;Decrease counter
	JR NZ -3 		;Loop until A=0
	ADD HL,DE 		;Next row
	DJNZ InnerB
	LD B,C			;Restore B
	POP HL 
	INC HL 
	DJNZ OuterB
;Part 3, Right Section
	LD HL,(DFile)
	LD DE,0300 		;DFile offset
	ADD HL,DE 
	LD DE,0018 		;Counter=24
	LD B,17			;Counter=23
@OuterC
	PUSH DE 
	PUSH HL
	PUSH DE 
@InnerC
	LD A,(Fill)
	LD (HL),A 
	LD A,(Speed)		;Get Speed
	DEC A			;Decrease counter
	JR NZ -3 		;Loop until A=0
	LD DE,FFE0 		;-32
	ADD HL,DE 
	POP DE 
	DEC E 
	PUSH DE 
	JR NZ InnerC
	POP DE 
	POP HL 
	INC HL
	POP DE 
	DEC E 
	DJNZ OuterC
	LD A,(Fill)
	LD (HL),A 
	RST 08
	FF
